## adabrowse 4.0.2

=== Makefile ===
#------------------------------------------------------------------------------
# Makefile for GNAT for adabrowse
#
# This makefile assumes that the ASIS libraries are in
# ADA_INCLUDE_PATH and ADA_OBJECTS_PATH. If this is not
# the case, uncomment and edit the alternate definitions
# of GCC_OPTIONS and LD_OPTIONS below, and comment the now
# uncommented ones.
#
# 05-APR-2002  TW  Initial version
# 02-MAY-2002  TW  Added 'nasty', changed the targets so they are macro refs.
# 08-MAY-2002  TW  Changed the makefile so that it uses 'get_gcc' to figure
#                  out the name of the gcc used by GNAT.
# 08-JUN-2003  TW  Added the automatic configuration stuff (with or without
#                  the project manager support).
# 20-NOV-2003  TW  Correction for splitting path lists: Unix has ':' as the
#                  path separator, whereas Windows uses ';'!
#------------------------------------------------------------------------------

# It is assumed that the pathes to your ASIS installation are in your
# ADA_INCLUDE_PATH and ADA_OBJECTS_PATH!

# This makefile has become pretty complicated, mainly because of things
# which we figure out when the makefile is run:
#
# 1. We determine the compiler name used by gnatmake by default, and
#    generate a package spec AD.Setup containing this name.
#
#    This is so because on some Linux installations, the compiler to
#    use for GNAT is not called "gcc" but "gnatgcc", and I want AdaBrowse
#    to default to this name.
#
#    To get the compiler's name and to create AD.Setup, we build a small
#    utility program called get_gcc.
#
# 2. We figure out whether the GNAT sources are available. This is indicated
#    by variable GNATSRC being set to the directory where the GNAT sources
#    are. If this variable is set, and the directory actually contains the
#    GNAT sources, then we try to configure AdaBrowse such that it uses the
#    GNAT project manager.
#
#    This is so because I don't want to distribute parts of the GNAT sources
#    with AdaBrowse. The reason is that the project manager and some files
#    it depends on differ between different GNAT versions, and furthermore
#    I think ACT wouldn't like my distributing extracts from the 3.15p and
#    3.16a sources. Also, I'd have to add more and more extracts as new
#    compiler versions appeared.
#
#    So the way chosen here is actually simpler: the GNAT sources, which
#    contain the project manager, are available from ACT, and users who
#    want project manager support in AdaBrowse can get them and then just
#    tell this makefile where they are. It isn't even necessary to try to
#    build GNAT. The only requiremnet is that the sources are consistent
#    with the GNAT and ASIS version used.
#
#    To configure AdaBrowse, we build a utility program in subdirectory
#    ./config and run it. The program then tries to build (using gnatmake)
#    a dummy application using the project manager. If that succeeds, it
#    configures AdaBrowse by generating two files ad-projects-impl.ads
#    and ad-projects-impl-get_parent.adb. if building the dummy application
#    failes, these files are set up such that AdaBrowse doesn't use the
#    GNAT project manager.
#
# Only after these two configuration steps building of AdaBrowse proper
# begins.
#
# And finally, this makefile is being complicated by the fact that the
# it has to work with the ancient GNU make 3.77 (distributed with GNAT 3.15p).

GCC_OPTIONS = -O2
LD_OPTIONS  = -lasis

host := $(shell gcc -dumpmachine)

RM        := rm -f
CP        := cp
ADABROWSE := adabrowse
NASTY     := nasty
GET_GCC   := get_gcc
EXE       :=
CONFIGURE := adconf
PATH_SEP  := :

ifeq "$(findstring mingw32, $(host))" "mingw32"
   # Assume we're on Windows
   RM        := cmd.exe /c del
   CP        := cmd.exe /c copy
   ADABROWSE := adabrowse.exe
   NASTY     := nasty.exe
   GET_GCC   := get_gcc.exe
   CONFIGURE := adconf.exe
   EXE       := .exe
   PATH_SEP  := ;
endif

# GNAT-specific gcc options: enable all warnings, and style checking.
# The style checking flags are nearly as plain "-gnaty", but do not
# check comment format, and do not require explicit specs for all
# subprograms. I chose this setting because these two things do not
# correspond at all to *my* style.

GNAT_OPTIONS := -gnatwa -gnaty3abefhiklmprt

GET_GCC_GEN  = get_gcc.o get_gcc.ali
GET_GCC_FULL = $(GET_GCC_GEN) get_gcc.txt get_gcc.use

ifdef GNATSRC

INTERNAL_GNAT_SRC  := $(subst \,/,$(subst \\,/,$(GNATSRC)))
INTERNAL_GNAT_SRC2 := $(INTERNAL_GNAT_SRC)

# Check that this GNAT source directory is correct:
ifeq "$(strip $(wildcard $(INTERNAL_GNAT_SRC)/prj-env.ads))" ""

INTERNAL_GNAT_SRC := $(INTERNAL_GNAT_SRC2)/ada

ifeq "$(strip $(wildcard $(INTERNAL_GNAT_SRC)/prj-env.ads))" ""

INTERNAL_GNAT_SRC := $(INTERNAL_GNAT_SRC2)/src/ada

ifeq "$(strip $(wildcard $(INTERNAL_GNAT_SRC)/prj-env.ads))" ""

$(error GNAT sources not found)
#
# Unfortunately, the error function doesn't work with GNU make 3.77,
# which is being distributed with GNAT 3.15p. (The GNAT 3.16a distribution
# contains the current GNU make 3.79.1.)
#
# Hence we deliberately use a non-existing dependency to make make stop
# with a halfway sensible message.

adabrowse : Cannot_Find_GNAT_Sources

endif

endif

endif

endif

# Figure out where the ASIS installation is.

Include_Dirs := $(subst \,/, $(subst $(PATH_SEP), ,$(ADA_INCLUDE_PATH)))
A4G_DIR := $(foreach dir,$(Include_Dirs),$(wildcard $(dir)/a4g.ali))

ifeq "$(strip $(A4G_DIR))" ""

# ADA_INCLUDE_PATH had better contain the asis directory.
$(error ADA_INCLUDE_PATH must contain the ASIS installation!)

adabrowse : ASIS_Not_On_ADA_INCLUDE_PATH

endif

ASIS_DIR := $(strip $(dir $(word 1, $(A4G_DIR))))

ifeq "$(ASIS_DIR)" ""

# Something went wrong.
$(error Cannot figure out the ASIS installation directory!)

adabrowse : ASIS_Not_Found

endif

ifdef ADABROWSE_GNATSRC

# Set the pathes so that we can compile files from the GNAT source
# distribution without problems. If we don't do that, we will not be
# able to link, because the GNAT compiler sources also contain
# the library sources. We must therefore make sure that the installed
# library always comes first!

# But don't do this only the variable comes from the comamnd line, and if
# ADABROWSE_GCC_LIB also is defined!

ifneq "$(findstring command,$(origin ADABROWSE_GNATSRC))" ""

ifdef ADABROWSE_GCC_LIB

export ADA_INCLUDE_PATH:=$(ASIS_DIR)$(PATH_SEP)$(ADABROWSE_GCC_LIB)$(PATH_SEP)$(ADABROWSE_GNATSRC)$(PATH_SEP)$(ADA_INCLUDE_PATH)
export ADA_OBJECTS_PATH:=$(ASIS_DIR)$(PATH_SEP)$(subst adainclude,adalib,$(ADABROWSE_GCC_LIB))$(PATH_SEP)$(ADA_OBJECTS_PATH)

endif

endif

# The GNAT sources may of course use internal GNAT units, so we don't
# want that warning. Also, we get spurious warnings on elaboration issues,
# all in GNAT sources. Suppress this warning, too.

GNAT_OPTIONS += -gnatwIL

endif

# MAIN TARGET: (first in this makefile)

all: ./config/$(CONFIGURE) run-conf
	$(MAKE) $(ADABROWSE) \
	ADABROWSE_GCC_LIB=$(dir $(subst \,/,$(shell $(shell get_gcc -gcc get_gcc.use) -print-libgcc-file-name)))adainclude \
	ADABROWSE_GNATSRC=$(INTERNAL_GNAT_SRC)

# Configuration stuff. We build an executable adconf, which then figures out
# from its parameters and by trying to compile a certain file whether or not
# we do have project manager support.

./config/$(CONFIGURE): get_gcc.use ./config/adconf.adb
	cd ./config; gnatmake -q -I.. adconf

# If adconf is called with two argument only (i.e., GNATSRC is not set), it
# configures AdaBrowse not to use the project manager.
#
# If adconf is called with four arguments, it configures AdaBrowse such that
# it *does* use the project manager, and then tries to compile the file
# ad-projects-impl_yes.adb. If that fails, it retries again after having
# made one single change to account for a difference between GNAT 3.15p and
# 3.16a. If compilation still fails, it reverts to the configuration not
# using the project manager.

run-conf:
	cd ./config; \
	./$(CONFIGURE) $(shell get_gcc -gcc get_gcc.use) \
	               $(ASIS_DIR) \
	               $(INTERNAL_GNAT_SRC) \
	               $(dir $(subst \,/,$(shell $(shell get_gcc -gcc get_gcc.use) -print-libgcc-file-name)))adainclude
	-cd ./config; $(CP) ad-projects-impl.ads ..
	-cd ./config; $(CP) ad-projects-impl_yes-get_parent.adb ..

# All this 'get_gcc' stuff here is GNAT specific: we try to dynamically
# figure out the name of the gcc used by GNAT. On some systems, it
# appears that this name is "gnatgcc", not "gcc"!

get_gcc.o :
	gnatmake -q -c -f get_gcc.adb

get_gcc.ali:
	gnatmake -q -c -f get_gcc.adb

$(GET_GCC): get_gcc.o get_gcc.ali get_gcc.adb
	gnatmake -q get_gcc

# Note: the dependency below first ensures that all the files we're
# going to delete in the rm command actually exist. This is a work-
# around for Win 2k, where make stops because cmd.exe /c del returns
# a failure exit code because some files may not exist. However, they
# must not exist when we run gnatmake, or we won't have the desired
# output in get_gcc.err. (The trick is that the first line in that
# file will be the compile command gnatmake uses for get_gcc.adb,
# which will start with the compiler name.)

get_gcc.use: $(GET_GCC)
	$(RM) $(GET_GCC) $(GET_GCC_GEN)
	gnatmake get_gcc 2>get_gcc.use

# Ok, finally we can build adabrowse! The first dependency handles the
# C file in the distribution. All the others may be regenerated.

ifneq "$(EXE)" ""

# On Windows, add a target "adabrowse"

adabrowse: $(ADABROWSE)
	-$(warning AdaBrowse built without reconfiguration)

endif

$(ADABROWSE): util-nl.o \
              ad-setup.ads \
              ad-projects-impl.ads ad-projects-impl_yes-get_parent.adb
	gnatmake $(GCC_OPTIONS) adabrowse -cargs $(GNAT_OPTIONS) \
	                                  -largs $(LD_OPTIONS)
	strip $(ADABROWSE)

$(NASTY): nasty.adb
	gnatmake nasty -cargs $(GCC_OPTIONS)

ad-setup.ads: get_gcc.use
	$(shell get_gcc -setup get_gcc.use)

util-nl.o: get_gcc.use util-nl.c
	$(shell get_gcc -gcc get_gcc.use) -c $(GCC_OPTIONS) util-nl.c

clean:
	$(RM) $(ADABROWSE) $(NASTY) $(GET_GCC) *.o *.ali

## adabrowse 4.0.3

=== Makefile ===
--- 
+++ 
@@ -15,6 +15,9 @@
 #                  the project manager support).
 # 20-NOV-2003  TW  Correction for splitting path lists: Unix has ':' as the
 #                  path separator, whereas Windows uses ';'!
+# 22-FEB-2005  TW  Make sure to use ./get_gcc instead of plain get_gcc so that
+#                  the makefile also works if a user doesn't have the current
+#                  directory in the PATH.
 #------------------------------------------------------------------------------
 
 # It is assumed that the pathes to your ASIS installation are in your
@@ -172,7 +175,7 @@
 # the library sources. We must therefore make sure that the installed
 # library always comes first!
 
-# But don't do this only the variable comes from the comamnd line, and if
+# But don't do this only the variable comes from the command line, and if
 # ADABROWSE_GCC_LIB also is defined!
 
 ifneq "$(findstring command,$(origin ADABROWSE_GNATSRC))" ""
@@ -198,7 +201,7 @@
 
 all: ./config/$(CONFIGURE) run-conf
 	$(MAKE) $(ADABROWSE) \
-	ADABROWSE_GCC_LIB=$(dir $(subst \,/,$(shell $(shell get_gcc -gcc get_gcc.use) -print-libgcc-file-name)))adainclude \
+	ADABROWSE_GCC_LIB=$(dir $(subst \,/,$(shell $(shell ./get_gcc -gcc get_gcc.use) -print-libgcc-file-name)))adainclude \
 	ADABROWSE_GNATSRC=$(INTERNAL_GNAT_SRC)
 
 # Configuration stuff. We build an executable adconf, which then figures out
@@ -220,10 +223,10 @@
 
 run-conf:
 	cd ./config; \
-	./$(CONFIGURE) $(shell get_gcc -gcc get_gcc.use) \
+	./$(CONFIGURE) $(shell ./get_gcc -gcc get_gcc.use) \
 	               $(ASIS_DIR) \
 	               $(INTERNAL_GNAT_SRC) \
-	               $(dir $(subst \,/,$(shell $(shell get_gcc -gcc get_gcc.use) -print-libgcc-file-name)))adainclude
+	               $(dir $(subst \,/,$(shell $(shell ./get_gcc -gcc get_gcc.use) -print-libgcc-file-name)))adainclude
 	-cd ./config; $(CP) ad-projects-impl.ads ..
 	-cd ./config; $(CP) ad-projects-impl_yes-get_parent.adb ..
 
@@ -276,10 +279,10 @@
 	gnatmake nasty -cargs $(GCC_OPTIONS)
 
 ad-setup.ads: get_gcc.use
-	$(shell get_gcc -setup get_gcc.use)
+	$(shell ./get_gcc -setup get_gcc.use)
 
 util-nl.o: get_gcc.use util-nl.c
-	$(shell get_gcc -gcc get_gcc.use) -c $(GCC_OPTIONS) util-nl.c
+	$(shell ./get_gcc -gcc get_gcc.use) -c $(GCC_OPTIONS) util-nl.c
 
 clean:
 	$(RM) $(ADABROWSE) $(NASTY) $(GET_GCC) *.o *.ali

=== debian/changelog ===
adabrowse (4.0.3-14) unstable; urgency=medium

  * Reupload to unstable for gnat-10 transition.
  * Standards-Version: 4.5.1.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 19 Dec 2020 15:10:33 +0100

adabrowse (4.0.3-13) experimental; urgency=medium

  * (style) Shorten 01-gnatmake.patch
  * (style) shorten 08-drop-util-nl.patch
  * (style) simplify and document gnat project
  * disable 01-gnatmake.patch
  * manual page: say that projects are not supported
  * Fail immediately if -P appears in the command line
  * Stop recommending gprbuild
  * Enable all linker checks
  * Merge debian/copyright stanzas with the same license
  * Simplify debian/rules
  * Debhelper 13 (no changes)
  * Rebuild with gnat-10 in experimental

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 17 Nov 2020 23:10:44 +0100

adabrowse (4.0.3-12) unstable; urgency=medium

  * Reupload to unstable for gnat-9 transition.
  * Standards-Version 4.5.0.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 26 Feb 2020 12:41:02 +0100

adabrowse (4.0.3-11) experimental; urgency=medium

  * Rebuild with gcc-9 and asis-2019.
  * Debhelper 12 does not compress examples anymore.
  * Standards-Version 4.4.1.
  * Simplify computation of gnat_version for recent gnats.
  * Update variable name in autopkgtests.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 07 Nov 2019 21:37:09 +0100

adabrowse (4.0.3-10) unstable; urgency=medium

  * Rebuild in unstable for gnat-8 transition.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 27 Oct 2018 15:09:35 +0200

adabrowse (4.0.3-9) experimental; urgency=medium

  [ Nicolas Boulenguez ]
  * Update dependencies and standards version (Closes: #903841)
  * Make flow and value of build flags visible in log.
  * Update some copyright details

  [ Adrian-Ken Rueegsegger ]
  * Add Nicolas Boulenguez to Uploaders

 -- Adrian-Ken Rueegsegger <ken@codelabs.ch>  Thu, 30 Aug 2018 17:17:48 +0200

adabrowse (4.0.3-8) unstable; urgency=medium

  [ Nicolas Boulenguez ]
  * Watch file format 4.
  * Minimal runtime test.
  * Install upstream changelog.
  * Include only one debian_packaging*.mk snippet.
  * HTTPS copyright format URL.
  * Debhelper 10. Remove explicit policy targets.
  * Rebuild with gnat 7 and asis 2017 (Closes: #872416).

  [ Adrian-Ken Rueegsegger ]
  * Update to Standards-Version 4.1.0

 -- Adrian-Ken Rueegsegger <ken@codelabs.ch>  Sat, 23 Sep 2017 16:31:20 +0200

adabrowse (4.0.3-7) unstable; urgency=medium

  [ Nicolas Boulenguez ]
  * Replace HTTP with HTTPS in VCS-* fields.
  * Switch to dpkg-source 3.0 (quilt) format.
  * Miscellaneous build improvements
  * Standards-Version: 3.9.8 (no changes).
  * Build with gnat-6, asis 2015 (Closes: #827099, #830401)
  * Escape dashes and fix typo in man page.
  * Register user guide in doc-base.
  * Switch to gprbuild as gnatmake as will drop project support.
  * Add gnat, gnat-6 runtime dependency

  [ Adrian-Ken Rueegsegger ]
  * Refresh patches to remove cruft
  * Rework '\n' handling to remove C helper function
  * Update debian/copyright file

 -- Adrian-Ken Rueegsegger <ken@codelabs.ch>  Fri, 08 Jul 2016 15:43:31 +0200

adabrowse (4.0.3-6) unstable; urgency=medium

  * Update debian/copyright file
  * Update to Standards-Version 3.9.6 (no changes)
  * Rebuild with gnat-4.9 and asis 2014 (Closes: #747557)
  * Add debian/watch file
  * Enable dpkg-buildflags hardening options
  * Simplify debian/rules
  * Update to debhelper 9

 -- Adrian-Ken Rueegsegger <ken@codelabs.ch>  Sun, 19 Oct 2014 12:43:15 +0200

adabrowse (4.0.3-5) unstable; urgency=low

  * Update to debhelper 8
  * Update debian/copyright file
  * Update to Standards-Version 3.9.2 (no changes)
  * Rebuild with gnat-4.6 and asis 2010 (Closes: #642609)
  * Fix debian-rules-missing-recommended-target warning
  * Update Vcs-Git URL

 -- Adrian-Ken Rueegsegger <ken@codelabs.ch>  Mon, 02 Jan 2012 20:53:55 +0000

adabrowse (4.0.3-4) unstable; urgency=low

  * Add gnat-4.4 dependency (Closes: #565618).

 -- Adrian-Ken Rueegsegger <ken@codelabs.ch>  Thu, 21 Jan 2010 21:17:50 +0100

adabrowse (4.0.3-3) unstable; urgency=low

  * Add Vcs-Browser and Vcs-Git entries.
  * Remove list of architectures (Closes: #525270, #542411).
  * Remove redundant build dependency for gnat.
  * Bump Standards-Version to 3.8.3.
  * Add README.source file.
  * Rebuild with latest GNAT and ASIS.
  * Use $(QUILT_STAMPFN) instead of patch target.

 -- Adrian-Ken Rueegsegger <ken@codelabs.ch>  Thu, 26 Nov 2009 20:53:44 +0100

adabrowse (4.0.3-2) unstable; urgency=low

  * Bring packaging up-to-date.

 -- Adrian-Ken Rueegsegger <ken@codelabs.ch>  Tue, 24 Feb 2009 22:47:12 +0100

adabrowse (4.0.3-1) unstable; urgency=low

  * Fix dh-clean-k-is-deprecated lintian warning.
  * Merging upstream version 4.0.3.
  * Sync copyright notice with upstream.

 -- Adrian-Ken Rueegsegger <ken@codelabs.ch>  Sun, 15 Feb 2009 18:46:14 +0100

adabrowse (4.0.2-7) unstable; urgency=low

  * New maintainer (Closes: #497018).
  * Bumped debhelper to 7.
  * Bumped policy to 3.8.0.

 -- Adrian-Ken Rueegsegger <ken@codelabs.ch>  Fri, 21 Nov 2008 16:54:20 +0100

adabrowse (4.0.2-6) unstable; urgency=low

  * Add mips, mipsel and ppc64.
  * Recompile using gnat-4.3 and asis 2007.
  * Update Standards-Version to 3.7.3 with no changes required.
  * debian/adabrowse.gpr: adjust to asis.gpr now being a library project
    file.  Closes: #479936.
  * debian/compat: new.
  * debian/rules: do not export DH_COMPAT anymore.

 -- Ludovic Brenta <lbrenta@debian.org>  Wed, 14 May 2008 23:40:56 +0200

adabrowse (4.0.2-5) unstable; urgency=medium

  * debian/control: add alpha, remove mips and mipsel.
  * Recompile now that asis is available on all architectures.
    Closes: #373247.

 -- Ludovic Brenta <lbrenta@debian.org>  Tue,  8 Aug 2006 23:48:07 +0200

adabrowse (4.0.2-4) unstable; urgency=low

  * debian/control:
    - Change my email address: now a full DD!
    - Update Build-Depends to gnat (>= 4.1) and libasis-dev.
      Closes: #330814.


=== debian/control ===
Source: adabrowse
Section: devel
Priority: optional
Maintainer: Adrian-Ken Rueegsegger <ken@codelabs.ch>
Uploaders: Nicolas Boulenguez <nicolas@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 gnat,
 gprbuild (>= 2021.0.0.0778b109-2),
 libasis2019.1-dev (>= 2019-4),
Standards-Version: 4.5.1
Homepage: http://home.datacomm.ch/t_wolf/tw/ada95/adabrowse/
Rules-Requires-Root: no
Vcs-Browser: https://git.codelabs.ch/?p=debian/adabrowse.git
Vcs-Git: https://git.codelabs.ch/git/debian/adabrowse.git -b debian

Package: adabrowse
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gnat
Description: HTML generator for Ada 95 library unit specifications
 AdaBrowse is a javadoc-like HTML generator for Ada 95 library unit
 specifications. It can also generate XML output; a DTD is included in
 the distribution.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS := 1
DEB_BUILD_MAINT_OPTIONS := hardening=+all
DEB_LDFLAGS_MAINT_APPEND := \
  -Wl,--no-allow-shlib-undefined \
  -Wl,--no-copy-dt-needed-entries \
  -Wl,--no-undefined
include /usr/share/dpkg/buildflags.mk
gnat_version := $(shell gnatgcc -dumpversion)
include /usr/share/ada/debian_packaging-$(gnat_version).mk

%:
	dh $@

# Prevent debhelper executing any upstream Makefile target.
.PHONY: $(addprefix override_dh_auto_, configure build test install clean)

override_dh_auto_build:
	gprbuild $(BUILDER_OPTIONS) -p debian/misc/adabrowse.gpr

.PHONY: override_dh_installchangelogs
override_dh_installchangelogs:
	dh_installchangelogs doc/versions.html

=== debian/tests/control ===
Tests: empty-ads

=== debian/watch ===
version=4
http://home.datacomm.ch/t_wolf/tw/ada95/adabrowse/ \
@PACKAGE@@ANY_VERSION@_src@ARCHIVE_EXT@
